/* A Recent Callers list generator for AdeptXBBS!

  This CMD File is used to GENERATE Tcall.Asc that Callers.Cmd will View

  This script was originally written by Julie Strietelmeier
  (julie@cel.cummins.com) on 03-05-95

  Modified 04-23-95 by Robert Stephens - 3:622/407
  (ourjs@net-unix.newcastle.edu.au)
  aka Jewfish in IRC #adept

  Features Added:
       - Didn't like Julie's Colors :-), Changed them
       - Adds numbers down the side of the callers list
       - Puts the Login and Logoff time on the list
       - Configurable Colours
       - Lots other things too!

  BUGS:
      - The way the login time is calculated, is by getting the time
        allowed each day "{UD" and subtracting the time remaining to
        get the Time Used. Unfortunately "{UB" doesn't function correctly
        so it couldn't be used. What this does mean however, is that if
        your Time Per Call and Time Per Day are different, the login
        Time will NOT be correct.

      - This is my first attempt at REXX scripting, so there may be
        some bugs, especially with the TimeUsed -> HH:MM code. Though I've
        extensively tested it and can't find any.
*/

ARG Line_Variable

/*
-------------------------------------------------------------------------------
 Configuration for AtEnd.Cmd
------------------------------------------------------------------------------- */

/* asciifile = 'd:\adept\text\calls.asc'  This is the OUTPUT file, change */
                                       /* this to the correct PATH */
NameColor   = "{FG"                    /* Color of Callers Name */
NodeColor   = "{FB"                    /* Color of Node Number */
BaudColor   = "{FB"                    /* Baud Rate Color */
CityColor   = "{FF"                    /* Users Location Color */
LogOnColor  = "{FG"                    /* LogOn Color */
LogOffColor = "{FG"                    /* LogOff Color */

/*              NOTE! You set the Background Color in Callers.Cmd
-------------------------------------------------------------------------------
 Congfiguration End
-------------------------------------------------------------------------------

                        Adept Color META Codes
                        ~~~~~~~~~~~~~~~~~~~~~~
+---------------------------------------------------------------------+
| Foreground ANSI Color :                                             |
| {F1  --  Black        {F2  --  Dark blue     {F3  --  Dark green    |
| {F4  --  Dark cyan    {F5  --  Dark red      {F6  --  Dark magenta  |
| {F7  --  Brown        {F8  --  Light gray    {F9  --  Dark gray     |
| {FA  --  Blue         {FB  --  Green         {FC  --  Cyan          |
| {FD  --  Red          {FE  --  Magenta       {FF  --  Yellow        |
| {FG  --  White                                                      |
+---------------------------------------------------------------------+
*/
name = adeptgetvar(Line_Variable,2)
if name = "Mario Dulisse" then return
city = adeptgetvar(Line_Variable,6)
bbsname = adeptgetvar(Line_Variable,137)
nodenum = adeptgetvar(Line_Variable,201)
if nodenum = '0' then exit
baudrate = adeptgetvar(Line_Variable,233)

PARSE VALUE time() WITH Hours ':' Mins ':' Secs

MinLimit = AdeptConvert(Line_Variable,"{UD")       /* Minute Limit per DAY, not call */
TimeLeft = AdeptConvert(Line_Variable,"{T0")       /* Time Left this call            */
TimeUsed = MinLimit - TimeLeft            /* Calculate the time used        */
State = AdeptConvert(Line_Variable,"{P2")

/* Begin Time Online -> HH:MM logon Time conversion code */
IF Mins = 0 THEN DO
   Mins = 60
   Hours = Hours - 1
   END
IF Hours = 0 THEN
   Hours = 24
IF TimeUsed > 60 THEN DO
        Tmins = Mins
        StoreTime = TimeUsed / 60
        TimeUsed = TimeUsed % 60
        Hours = Hours - TimeUsed
        StoreTime = StoreTime - TimeUsed
        Mins = 60 * StoreTime
        PARSE VALUE TRUNC(Mins,0) WITH Mins
        Mins = Tmins - Mins
        IF Mins < 0 THEN DO
           Hours = Hours - 1
           Mins = 60 + Mins
           SIGNAL Hello
           END
        IF Mins < 10 THEN DO
           Mins = '0'Mins
           SIGNAL Hello
           END
END
ELSE
       IF TimeUsed > Mins THEN DO
           Mins = TimeUsed - Mins
           Mins = 60 - Mins
           Hours = Hours - 1
           IF Mins < 10 THEN DO
              Mins = '0'Mins
              SIGNAL Hello
              END
       END
       ELSE
           Mins = Mins - TimeUsed
           IF Mins < 10 THEN DO
              Mins = '0'Mins
              SIGNAL Hello
              END
/* END Time Online -> HH:MM logon Time conversion code */

Hello:
OnTime = Hours':'Mins
PARSE VALUE time() WITH Hours ':' Mins ':' Secs
OffTime = Hours':'Mins
city = city', 'state
name = NameColor''name
nodenum = NodeColor''nodenum
baudrate = BaudColor''baudrate
city = CityColor''city
ontime = LogOnColor''ontime
offtime = LogOffColor''offtime
       c1 = insert(name,'',5,23)
       c2 = insert(nodenum,c1,31,5)
       c3 = insert(baudrate,c2,39,8)
       c4 = insert(city,c3,49,19)
       c5 = insert(ontime,c4,70,8)
       c6 = insert(offtime,c5,80,8)
asciifile = 'D:\adept\text\calls.asc'
       caller = lineout(asciifile,c6)
return
/*                        Have a nice day! - Jewfish                          */
