/* New Rexx .Menu converter by Jewfish
   Bugs Fixed
   ----------
   1. Possible Bug in Parsing '.' Missing
   2. Bugs fixed with comments and blank lines
   3. Better detection of converted menus
   4. This script can be run anywhere on the system and it'll find the files
      to convert still.
*/
Say 'Adept v1.0x -> v1.08x Menu Converter'
Call CharOut, 'Enter in the Drive Letter Adept is installed on. [ie D:] : '
Pull Drive
If Pos(':',Drive) = 0 Then Drive = Drive || ':'

Call RxFuncAdd 'SysLoadFuncs', 'Rexxutil', 'SysLoadFuncs'
Call 'SysLoadFuncs'

OldDirectory = Directory()
Call Directory(Drive || '\Adept\Menus')
Call SysFileTree '*.menu', 'fline', 'FO'

Do i = 1 To fline.0
    FileName = SubStr(Fline.i,LastPos('\',Fline.i) + 1)
    OldFile = FileName || '.Old'
    NewFile = FileName
    If Stream(OldFile,'c','query exists') \= '' Then Do
       Say
       Say 'Old Backup Menus (*.Menu.Old) already exist!.  Menus already converted ?'
       Say 'If not, erase the old files then re-run. Exiting ...'
       Call Directory(OldDirectory)
       Exit
    End
    '@ren ' || NewFile || ' ' || OldFile || ' >nul'
    PromptData = Strip(LineIn(OldFile))
    If Translate(Word(PromptData,1)) = 'BEGINMENU' Then Do
       Say NewFile || ' has already been converted!'
       Iterate
    End
    Parse Var PromptData PromptText ',' Colour ',' MenuFilename ',' MenuLocation ',' MenuFlags
    Call LineOut NewFile,'BEGINMENU'
    If (PromptText \= '') Then Call LineOut NewFile,'    PROMPT           ' || PromptText
    If (Colour \= '') Then Call LineOut NewFile,'    PROMPTCOLOR      ' || Colour
    If (MenuFileName \= '') Then Call LineOut NewFile,'    DISPLAYFILE      ' || MenuFileName
    If (MenuLocation \= '') Then Call LineOut NewFile,'    MENULOCATION     ' || MenuLocation
    If (MenuFlags \= '') Then Call LineOut NewFile,'    MENUFLAGS        ' || MenuFlags

    Do While Lines(OldFile) = 1
       Data = Strip(LineIn(OldFile))
       If (Data = ';' | Data = '' | Left(Data,1) = ';') Then Iterate
       Parse Var Data Key ',' Command ',' OutputString ',' DataString ',' Colour ',' MinAge ',' MaxAge ',' Sec1 ',' Sec2 ',' Flags1 ',' Flags2 ',' StartTime ',' EndTime ',' Gender ',' MinCredit ',' MaxCredit ',' MinTime ',' MaxTime ',' MinCall ',' MaxCall ',' MinPosts ',' MaxPosts ',' MinUpl ',' MaxUpl ',' MinDl ',' MaxDl ',' Group ',' PortFlags .
       Call LineOut NewFile, '    BEGINMENUITEM'
       If (Key \= '') Then Call LineOut NewFile, '        KEY ' || Key
       Else Say 'Warning, menu option has no "KEY" assigned'
       If (Command \= '') Then Call LineOut NewFile, '        MENUCOMMAND ' || Command
       Else Say 'Warning, menu has no associated "COMMAND" with it'
       If (OutputString \= '') Then Call LineOut NewFile, '        DISPLAYSTRING ' || OutputString
       If (Colour \= '') Then Call LineOut NewFile, '        DISPLAYCOLOR ' || Colour
       If (DataString \= '') Then Call LineOut NewFile, '        DATAOPTION ' || DataString
       If (MinAge \= '') Then Call LineOut NewFile, '        MINAGE ' || MinAge
       If (MaxAge \= '') Then Call LineOut NewFile, '        MAXAGE           ' || MaxAge
       If (Sec1 \= '') Then Call LineOut NewFile, '        MINSEC1          ' || Sec1
       If (Sec2 \= '') Then Call LineOut NewFile, '        MINSEC2          ' || Sec2
       If (Flags1 \= '') Then Call LineOut NewFile, '        FLAGS1           ' || Flags1
       If (Flags2 \= '') Then Call LineOut NewFile, '        FLAGS2           ' || FLags2
       If (Gender \= '') Then Call LineOut NewFile, '        GENDER           ' || Gender
       If (StartTime \= '') Then Call LineOut NewFile, '        STARTTIME        ' || StartTime
       If (EndTime \= '') Then Call LineOut NewFile, '        ENDTIME          ' || EndTime
       If (MinTime \= '') Then Call LineOut NewFile, '        MINONLINETIME    ' || MinTime
       If (MaxTime \= '') Then Call LineOut NewFile, '        MAXONLINETIME    ' || MaxTime
       If (MinCall \= '') Then Call LineOut NewFile, '        MINCALLS         ' || MinCall
       If (MaxCall \= '') Then Call LineOut NewFile, '        MAXCALLS         ' || MaxCall
       If (MinPosts \= '') Then Call LineOut NewFile, '        MINPOSTS         ' || MinPosts
       If (MaxPosts \= '') Then Call LineOut NewFile, '        MAXPOSTS         ' || MaxPosts
       If (MinUpl \= '') Then Call LineOut NewFile, '        MINUPLOADS       ' || MinUpl
       If (MaxUpl \= '') Then Call LineOut NewFile, '        MAXUPLOADS       ' || MaxUpl
       If (MinDl \= '') Then Call LineOut NewFile, '        MINDOWNLOADS     ' || MinDl
       If (MaxDl \= '') Then Call LineOut NewFile, '        MAXDOWNLOADS     ' || MaxDl
       If (Group \= '') Then Call LineOut NewFile, '        GROUP            ' || Group
       If (PortFlags \= '') Then Call LineOut NewFile, '        PORTFLAGS        ' || PortFlags
       Call LineOut NewFile, '    ENDMENUITEM'
    End
    Call LineOut NewFile, 'ENDMENU'
    Call Stream NewFile,'c','close'
    Say 'Converted ' || NewFile
End

Say 'All Menus converted!'
Call Directory(OldDirectory)
say 'Done..'
